Skip to main content

Backtracking

Backtracking may be one of the most "brute-force" algorithm. When all the other algorithms, such as, breadth-first-search (bfs), depth-first-search(dfs), and others, do not work, we can consider backtracking. With backtracking, the problem will be solved incrementally.

One of key features of backtracking is that we will do a "try step" first. Then we continue the search. If eventually the result is not valid, we have to back-track the "try step". And then make a second "try step", and so on, until make all the possible try steps.

If there are N steps in total, and for each step, there are M possible trials, then the overall complexity is (M^N), which increases really fast as a function of M or N.

The trial structure is layer by layer: once you make a trial, then based on this trial, you may continue to make the next trial on the "next layer", since we do not know yet whether the trials is a valid one or not. So we may have a chain of trials in different layers. Once we reach the step (converging to the base case) to know the correctness, we can make a decision. If it is valid, it means we find a good (valid) solution; if not, we need to go back to the "most recent" trial (or the one in the most recent layer of trial), reset the trial, and try the second possible route, ..., until we finish all the trial in the last layer.

If all the trials in the last layer do not work, then we need to go back to the second last layer, and reset the trial that we had made there, and try the second possible route, ...

Until we iterate all the possible trials in "all the layers".

Maybe you still do not get the point of the backtracking, but no worries, there are many classic questions to help illustrate the concept of it, some of which will be included in the question posts below.

To sum up, backtracking is

1. pretty brute-force;

2. make a trial step first; if does not work eventually, need to step back and start the next possible trial;

3. solve problems incrementally


Question List


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class